#ifndef _COMPAT_STRATUS_H
#define _COMPAT_STRATUS_H
#include <xen/compat.h>
#include <public/stratus.h>
#pragma pack(4)
struct compat_cr4_struct {
 int rw;
 unsigned int cr4;
};

struct compat_cpuid_struct {
 unsigned int op;
 unsigned int eax, ebx, ecx, edx;
};

struct compat_msr_struct {
 int rw;
 unsigned int msr;
 unsigned int val;
};

struct compat_lapic_struct {
 int id;
};

struct compat_rw_struct {
 int rw;
 int region;
 void *data;
 unsigned int where;
 int size;
};

struct compat_smi_struct {
 unsigned int dest;
};

struct compat_hbv_memset_struct {
 int val;
 int size;
};

struct compat_pf_stratus_call {
 int cmd;
 int ret;
 union {
  struct compat_smi_struct compat_smi;
  struct compat_hbv_memset_struct compat_hbv_m;
  struct compat_rw_struct compat_rw;
  struct compat_lapic_struct compat_ls;
  struct compat_cr4_struct compat_cr4;
  struct compat_cpuid_struct compat_cpuid;
  struct compat_msr_struct compat_msr;
 } u;
};
#pragma pack()
#endif /* _COMPAT_STRATUS_H */
